
Type TExplosion
	Field mesh
	Field xs#,ys#,zs#
	Field size#
	Field sizeup#
	Field sizechange#
End Type

Function Exp_CreateExplosion.TExplosion(x#,y#,z#, r,g,b, size#=0.3, sizeup#=0.2, sizechange#=-0.01, detail=5, xs#=0,ys#=0,zs#=0)
	e.TExplosion = New TExplosion
	
	e\mesh = CreateSphere(detail)
	EntityColor e\mesh, r,g,b
	PositionEntity e\mesh, x,y,z
	e\size = size
	e\sizeup = sizeup
	e\sizechange = sizechange
	
	e\xs = xs
	e\ys = ys
	e\zs = zs
	
	Return e
End Function

Function Exp_Update()
	For e.TExplosion = Each TExplosion
		e\size = e\size + e\sizeup
		e\sizeup = e\sizeup + e\sizechange
		ScaleEntity e\mesh, e\size, e\size, e\size
		
		TranslateEntity e\mesh, e\xs, e\ys, e\zs
		
		If e\size < 0 Then
			FreeEntity e\mesh
			Delete e
		EndIf
	Next
End Function