Const EXTRA_HEALTH = 1
Const EXTRA_SHOT = 2
Const EXTRA_SHIELD = 3


Type TExtra
	Field typ
	Field mesh
End Type

Function Extra_CreateExtra.TExtra(typ, x#,z#)
	e.TExtra = New TExtra
	
	e\typ = typ
	e\mesh = CreateCube()
	PositionEntity e\mesh, x,1.5,z
	ScaleEntity e\mesh,.5,.5,.5
	
	Select typ
	Case EXTRA_HEALTH
		EntityColor e\mesh, 255,0,0
	Case EXTRA_SHOT
		EntityColor e\mesh, 200,200,40
	Case EXTRA_SHIELD
		EntityColor e\mesh, 180,0,120
	End Select
	
	Return e
End Function

Function Extra_Update()
	If Rand(500) = 1 Then Extra_CreateExtra(Rand(1,3), Rnd(Map_Size),Rnd(Map_Size))
	For e.TExtra = Each TExtra
		TurnEntity e\mesh, 0,1,0
		PositionEntity e\mesh, EntityX(e\mesh), 1.5+Sin(EntityYaw(e\mesh)), EntityZ(e\mesh)
		For t.TTank = Each TTank
			If EntityDistance(t\mesh, e\mesh) < 3
				Select e\typ
				Case EXTRA_HEALTH
					For i = 0 To 5
						Exp_CreateExplosion(EntityX(e\mesh)+Rnd(-.5,.5),EntityY(e\mesh)+Rnd(-.5,.5),EntityZ(e\mesh)+Rnd(-.5,.5),255,0,0, Rnd(0,0.3), Rnd(0.2,0.3), -Rnd(0.02,0.03), Rand(4,6), Rnd(-.1,.1),Rnd(-.1,.1),Rnd(-.1,.1))
					Next
					t\hitpoints = t\hitpoints + 30
				Case EXTRA_SHOT
					For i = 0 To 5
						Exp_CreateExplosion(EntityX(e\mesh)+Rnd(-.5,.5),EntityY(e\mesh)+Rnd(-.5,.5),EntityZ(e\mesh)+Rnd(-.5,.5),200,200,40, Rnd(0,0.3), Rnd(0.2,0.3), -Rnd(0.02,0.03), Rand(4,6), Rnd(-.1,.1),Rnd(-.1,.1),Rnd(-.1,.1))
					Next
					If t\shotmode<5 Then t\shotmode = t\shotmode + 1
				Case EXTRA_SHIELD
					For i = 0 To 5
						Exp_CreateExplosion(EntityX(e\mesh)+Rnd(-.5,.5),EntityY(e\mesh)+Rnd(-.5,.5),EntityZ(e\mesh)+Rnd(-.5,.5),180,0,120, Rnd(0,0.3), Rnd(0.2,0.3), -Rnd(0.02,0.03), Rand(4,6), Rnd(-.1,.1),Rnd(-.1,.1),Rnd(-.1,.1))
					Next
					t\shieldmode = t\shieldmode + 500
				End Select
				
				FreeEntity e\mesh
				Delete e
				Exit
			EndIf
		Next
	Next
End Function