Const MAP_TYPE = 1

Const MAP_TREE		= 1
Const MAP_BUILDING	= 2

Const MAP_STATE_BURNING = 1
Const MAP_STATE_CRASHING = 2

Type TMapObject
	Field typ
	Field mesh
	Field hitpoints#
	Field size
	Field state
End Type

Global Map_Terrain
Global Map_Sun
Global Map_Size

Function Map_GenerateMap(size)
	Map_Size = size
	Map_Terrain = CreateTerrain(size)
	EntityColor Map_Terrain, 100,100,80
	Map_Plane = CreatePlane()
	EntityColor Map_Plane, 100,100,80
	
	Map_Sun = CreateLight(1)
	RotateEntity Map_Sun, 60,0,0
	
	For i = 0 To size / 4
		Repeat
			x# = Rnd(size)
			z# = Rnd(size)
			osize = Rand(2,5)
			okay = 1
			For o.TMapObject = Each TMapObject
				If (x-EntityX(o\mesh))^2 + (z-EntityZ(o\mesh))^2 < osize * osize * 4 Then okay = 0
			Next
		Until okay
		
		Map_CreateObject(Rand(1,2), x,0,z, osize)
	Next
End Function

Function Map_CreateObject.TMapObject(typ, x#,y#,z#, size)
	o.TMapObject = New TMapObject
	o\typ	= typ
	o\hitpoints = size * 5
	
	Select typ
	Case MAP_TREE
		o\mesh = CreateCone()
		EntityColor o\mesh, Rand(40), Rand(70,200), Rand(20,30)
		tmp# = Rnd(1,3)
		ScaleEntity o\mesh, size*1.2, size*tmp, size*1.2 
		RotateEntity o\mesh, Rnd(-10,10),Rnd(-100,100),Rnd(-10,10)
		o\size = size * 1.2
		o\hitpoints = o\hitpoints / 2
	Case MAP_BUILDING
		o\mesh = CreateCube()
		c = Rand(180,230)
		EntityColor o\mesh,c,c,c
		tmp# = Rnd(1,3)
		ScaleEntity o\mesh, size*Rnd(1.8,2.4), size*tmp, size*2 
		RotateEntity o\mesh, 0,Rnd(-3,3),0
		o\size = 2*size
	End Select
	
	EntityType o\mesh, MAP_TYPE
	
	PositionEntity o\mesh, x,y+size*tmp*.8,z
	
	Return o
End Function

Function Map_Update()
	For o.TMapObject = Each TMapObject
		If o\hitpoints <= 0 Then o\state = MAP_STATE_CRASHING
		Select o\state
		Case MAP_STATE_BURNING
			If Rand(5)=2
				c = Rand(100,190)
				Exp_CreateExplosion(EntityX(o\mesh)+Rnd(-.3,.3),EntityY(o\mesh)+Rnd(-.3,.3),EntityZ(o\mesh)+Rnd(-.3,.3),c,c,c, Rnd(0.1,0.2), Rnd(0.1,0.2), -Rnd(0.002,0.005), Rand(4,6), Rnd(-.1,.1),Rnd(.1,.25),Rnd(-.1,.1))
			EndIf
			
			o\hitpoints = o\hitpoints - 0.02
			If o\hitpoints <= 3
				EntityColor o\mesh,0,10,0
				o\state = 0
			EndIf
		Case MAP_STATE_CRASHING
			TurnEntity o\mesh,0.5,0,0.1
			MoveEntity o\mesh,0,-.2,0
			
			For i = 0 To Ceil(o\size/4)
				c = Rand(100,190)
				Exp_CreateExplosion(EntityX(o\mesh)+Rnd(-o\size,o\size)*1.1,Rnd(-.4,.3),EntityZ(o\mesh)+Rnd(-o\size,o\size)*1.1,c,c,c, Rnd(0.1,0.2), Rnd(0.1,0.2), -Rnd(0.003,0.01), Rand(4,6), Rnd(-.1,.1),Rnd(.1,.25),Rnd(-.1,.1))
			Next
			
			If EntityY(o\mesh) < -10 Then FreeEntity o\mesh : Delete o
		End Select
	Next
End Function