Const SHOT_TYPE = 3

Type TShot
	Field xs#, ys#, zs#
	Field mesh
End Type

Function Shot_CreateShot.TShot(x#,y#,z#, xs#, ys#, zs#)
	s.TShot = New TShot
	
	s\mesh = CreateSphere(4)
	ScaleEntity s\mesh, .15, .15, .35
	PositionEntity s\mesh, x,y,z
	
	Exp_CreateExplosion.TExplosion(x#+xs,y#+ys,z#+zs, Rand(200,250),Rand(150,200),Rand(20), 0.2, 0.1, -0.02, 3)
	
	s\xs = xs
	s\ys = ys
	s\zs = zs
	
	EntityType s\mesh, SHOT_TYPE
	EntityRadius s\mesh, .3
	ResetEntity s\mesh
	
	Return s
End Function

Function Shot_Update()
	For s.TShot = Each TShot
		s\ys = s\ys - 0.001
		TranslateEntity s\mesh, s\xs, s\ys, s\zs
		AlignToVector s\mesh, s\xs, s\ys, s\zs,3
		
		coll = EntityCollided(s\mesh,MAP_TYPE)
		If coll
			For o.TMapObject = Each TMapObject
				If o\mesh = coll Then
					o\hitpoints = o\hitpoints - 5
					If o\typ = MAP_TREE Then o\state = MAP_STATE_BURNING
				EndIf
			Next
		Else
			coll = EntityCollided(s\mesh,TANK_TYPE)
			If coll Then
				For t.TTank = Each TTank
					If t\mesh = coll Then
						If t\shieldmode > 0 Then 
							t\hitpoints = t\hitpoints - 5
						Else
							t\hitpoints = t\hitpoints - 23
							If t\shotmode > 0 Then t\shotmode = t\shotmode - 1 
						EndIf
					EndIf
				Next
			EndIf
		EndIf
		
		If EntityY(s\mesh) < 0 Or coll <> 0 Then
			For i = 0 To 5
				Exp_CreateExplosion(EntityX(s\mesh)+Rnd(-.5,.5),EntityY(s\mesh)+Rnd(-.5,.5),EntityZ(s\mesh)+Rnd(-.5,.5),Rand(220,255),Rand(80,200),Rand(30,80), Rnd(0,0.3), Rnd(0.2,0.3), -Rnd(0.02,0.03), Rand(4,6), Rnd(-.1,.1),Rnd(-.1,.1),Rnd(-.1,.1))
			Next
			For i = 0 To 5
				c = Rand(100,190)
				Exp_CreateExplosion(EntityX(s\mesh)+Rnd(-.3,.3),EntityY(s\mesh)+Rnd(-.3,.3),EntityZ(s\mesh)+Rnd(-.3,.3),c,c,c, Rnd(0.1,0.2), Rnd(0.1,0.2), -Rnd(0.005,0.01), Rand(4,6), Rnd(-.1,.1),Rnd(.1,.4),Rnd(-.1,.1))
			Next
			FreeEntity s\mesh
			Delete s
		End If
	Next
End Function