
Type TTank
	Field id
	
	Field speed#
	Field turnspeed#
	Field reload
	Field hitpoints
	
	Field mesh
	Field chainpiv
	Field chains, chain1, chain2
	Field turret
	Field gun
	Field shadow
	Field shield
	
	Field shieldmode
	Field shotmode
	
	Field cam
	Field reset
	
	Field kills
End Type

Const TANK_TYPE = 2

Function Tank_CreateTank.TTank(player_id)
	t.TTank = New TTank
	t\id = player_id
	
	t\mesh = CreateCube()
	ScaleMesh t\mesh, .8,.3,1
	MoveEntity t\mesh, 0,.5,0
	EntityColor t\mesh, 10,180,0
	
	t\chainpiv = CreatePivot(t\mesh)
	MoveEntity t\chainpiv, 0,-.3,0
	ScaleEntity t\chainpiv, .3,.3,1
	
	t\chains = CreatePivot(t\chainpiv)
	chain = CreateCylinder(8,1,t\chains)
	RotateEntity chain, 90, 90, 0
	PositionEntity chain, -3,0,0
	EntityColor chain, 0,150,0
	t\chain1 = chain
	chain = CreateCylinder(8,1,t\chains)
	RotateEntity chain, 90, 90, 0
	PositionEntity chain, 3,0,0
	EntityColor chain, 0,150,0
	t\chain2 = chain
	
	t\turret = CreateCylinder(5,1,t\mesh)
	MoveEntity t\turret, 0,.6,0
	ScaleMesh t\turret, 0.5,0.4,0.45
	EntityColor t\turret, 255*(player_id=2),50,255*(player_id=1)
	
	t\gun = CreateCylinder(5,1,t\turret)
	PositionMesh t\gun, 0,1.2,0
	ScaleMesh t\gun, 0.2, 0.7, 0.2
	RotateEntity t\gun, 90,0,0
	
	t\shadow = CreateCube(t\mesh)
	EntityColor t\shadow, 128,128,128
	EntityBlend t\shadow, 2
	ScaleEntity t\shadow, 1.2,0.0002,1
	
	If player_id > 0
		t\cam = CreateCamera(t\mesh)
		MoveEntity t\cam,0,7,-3
		TurnEntity t\cam,25,0,0
		CameraViewport t\cam, (player_id-1)*(Main_Width / 2), 0,  Main_Width/2, Main_Height
		PositionEntity t\mesh, (player_id-1)*120+4,.5,(player_id-1)*120+4
		If player_id = 2 Then TurnEntity t\mesh, 0, 180, 0
		
		CameraClsColor t\cam, 50,150,220
		CameraFogColor t\cam, 50,150,220
		CameraFogRange t\cam, 50,100
		CameraRange t\cam,0.5,120
		CameraFogMode t\cam,1
	EndIf
	
	t\shield = CreateSphere(8,t\mesh)
	ScaleEntity t\shield,2, 1.5, 2
	EntityColor t\shield,100, 0, 200
	EntityAlpha t\shield,.5
	EntityShininess t\shield,.5
	
	EntityRadius t\mesh, 1.2
	EntityBox t\mesh, -1,-.5,-1, 2,1,2
	EntityType t\mesh, TANK_TYPE
	
	Tank_Reset(t.TTank)
	
	Return t
End Function


Function Tank_Update()
	For t.TTank = Each TTank
		If t\reset > 0 Then
			t\reset = t\reset - 1
			If t\reset <= 0 Then Tank_Reset(t)
		Else
			TurnEntity t\mesh,0,t\turnspeed,0
			MoveEntity t\mesh,0,0,t\speed
			
			TurnEntity t\chain1, 0,t\speed*100 - t\turnspeed,0
			TurnEntity t\chain2, 0,t\speed*100 + t\turnspeed,0
			
			If Abs(t\speed) > 0.001 And Rand(0,16-Abs(t\speed)*100)=0 Then
				c = Rand(100,190)
				If Rand(0,1)=1
					Exp_CreateExplosion(EntityX(t\chain1,1)+Rnd(-.1,.1),EntityY(t\chain1,1)+Rnd(-.1,.1),EntityZ(t\chain1,1)+Rnd(-.1,.1),c,c,c, Rnd(0.05,0.1), Rnd(0.04,0.07), -Rnd(0.001,0.005), Rand(3,4), Rnd(-.01,.01),Rnd(.001,.01),Rnd(-.01,.01))
				Else
					Exp_CreateExplosion(EntityX(t\chain2,1)+Rnd(-.1,.1),EntityY(t\chain2,1)+Rnd(-.1,.1),EntityZ(t\chain2,1)+Rnd(-.1,.1),c,c,c, Rnd(0.05,0.1), Rnd(0.04,0.07), -Rnd(0.001,0.005), Rand(3,4), Rnd(-.01,.01),Rnd(.001,.01),Rnd(-.01,.01))
				EndIf
			EndIf
			
			PositionEntity t\mesh, EntityX(t\mesh),TerrainY(Map_Terrain,EntityX(t\mesh),0,EntityZ(t\mesh))+.5,EntityZ(t\mesh)
			
			PositionEntity t\shadow, EntityX(t\mesh)+.2,TerrainY(Map_Terrain,EntityX(t\mesh)+.2,0,EntityZ(t\mesh)+.2)+.001,EntityZ(t\mesh)+.2, 1
			RotateEntity t\shadow, 0,EntityYaw(t\mesh),0,1
			
			t\speed = t\speed * .7
			t\turnspeed = t\turnspeed * .8
			
			If t\shieldmode > 0
				t\shieldmode = t\shieldmode - 1
				ShowEntity t\shield
			Else
				HideEntity t\shield
			EndIf
			
			If t\reload > 0
				t\reload = t\reload - 1
			Else
				t\reload = 0
			EndIf
			PositionEntity t\gun, 0,0,(-t\reload+20)*.004
			
			PositionEntity t\cam,0,7,-3-t\speed*10
			RotateEntity t\cam,25-t\speed*100,t\turnspeed*10,0
			
			If t\hitpoints <= 0 Then
				For i = 0 To 15
					Exp_CreateExplosion(EntityX(t\mesh)+Rnd(-1,1),EntityY(t\mesh)+Rnd(-1,1),EntityZ(t\mesh)+Rnd(-1,1),Rand(220,255),Rand(80,200),Rand(30,80), Rnd(0,0.3), Rnd(0.2,0.3), -Rnd(0.01,0.015), Rand(4,6), Rnd(-.3,.3),Rnd(-.2,.2),Rnd(-.3,.3))
				Next
				For i = 0 To 10
					c = Rand(100,190)
					Exp_CreateExplosion(EntityX(t\mesh)+Rnd(-.5,.5),EntityY(t\mesh)+Rnd(-.5,.5),EntityZ(t\mesh)+Rnd(-.5,.5),c,c,c, Rnd(0.1,0.2), Rnd(0.1,0.2), -Rnd(0.002,0.005), Rand(4,6), Rnd(-.1,.1),Rnd(.1,.4),Rnd(-.1,.1))
				Next
				EntityParent t\cam, 0
				HideEntity t\mesh
				t\reset = 200
				If t\id = 1 Then Main_Player2\kills = Main_Player2\kills + 1
				If t\id = 2 Then Main_Player1\kills = Main_Player1\kills + 1
			EndIf 
		EndIf
		Gui_DrawProgressBar((t\id-1)*(Main_Width / 2)+20, Main_Height-30,200,15, Float(t\hitpoints) / 100.0)
		x = 10
		y = 10
		For i = 1 To t\kills
			Color 0,0,0
			Rect x+(t\id-1)*Main_Width/2,y,15,15
			x = x + 20
			If x > Main_Width/2 Then x = 10 : y=y+20
		Next
	Next
End Function

Function Tank_Reset(t.TTank)
	t\hitpoints = 100
	EntityParent t\cam, t\mesh, 0
	PositionEntity t\cam,0,0,0
	RotateEntity t\cam,0,0,0
	PositionEntity t\mesh, (t\id-1)*120+4,.5,(t\id-1)*120+4
	RotateEntity t\mesh, 0, 180*(t\id=2), 0
	ShowEntity t\mesh
	ResetEntity t\mesh
	PositionEntity t\cam,0,7,-3
	RotateEntity t\cam,25,0,0
	t\shieldmode = 0
	t\speed = 0
	t\turnspeed = 0
End Function


Function Tank_Control(t.TTank,forward,backwards,turnleft,turnright, fire)
	t\speed = t\speed + Float(forward-backwards) * .04
	
	t\turnspeed = t\turnspeed + Float(turnleft-turnright)*.25
	
	If fire=1 And t\reload <= 0
		t\reload = 40
		x0# = EntityX(t\gun,1)
		y0# = EntityY(t\gun,1)
		z0# = EntityZ(t\gun,1)
		temppiv = CreatePivot(t\gun)
		TurnEntity temppiv,90,0,0
		MoveEntity temppiv,0,0,-1-t\speed
		x1# = EntityX(temppiv,1)
		y1# = EntityY(temppiv,1)
		z1# = EntityZ(temppiv,1)
		Shot_CreateShot(x1,y1,z1, x1-x0, y1-y0+.01, z1-z0)
		
		For i = 1 To t\shotmode
			x0# = EntityX(t\gun,1)
			y0# = EntityY(t\gun,1)
			z0# = EntityZ(t\gun,1)
			PositionEntity temppiv,0,0,0
			RotateEntity temppiv,90,0,0
			TurnEntity temppiv,0,i*30.0/t\shotmode,0,1
			MoveEntity temppiv,0,0,-1-t\speed
			x1# = EntityX(temppiv,1)
			y1# = EntityY(temppiv,1)
			z1# = EntityZ(temppiv,1)
			Shot_CreateShot(x1,y1,z1, x1-x0, y1-y0+.01, z1-z0)
			
			x0# = EntityX(t\gun,1)
			y0# = EntityY(t\gun,1)
			z0# = EntityZ(t\gun,1)
			PositionEntity temppiv,0,0,0
			RotateEntity temppiv,90,0,0
			TurnEntity temppiv,0,-i*30.0/t\shotmode,0,1
			MoveEntity temppiv,0,0,-1-t\speed
			x1# = EntityX(temppiv,1)
			y1# = EntityY(temppiv,1)
			z1# = EntityZ(temppiv,1)
			Shot_CreateShot(x1,y1,z1, x1-x0, y1-y0+.01, z1-z0)
		Next
		
		FreeEntity temppiv
	EndIf
End Function


Function Tank_HidePlayerCams()
	For t.TTank = Each TTank
		If t\cam <> 0 Then HideEntity t\cam
	Next
End Function

Function Tank_ShowPlayerCams()
	For t.TTank = Each TTank
		If t\cam <> 0 Then ShowEntity t\cam
	Next
End Function